
/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Irina Golovan
 * Student ID: 9822732
 * Section:    AF
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
	

#define TRUE    		1
#define FALSE   		0

/* status */
#define STATUS_ADD_SHAPE 1
#define STATUS_ADD_MESSAGE 2
#define STATUS_SELECTED 3
#define SELECT_OBJECT 4
#define STATUS_QUIT 5

/* Configure the appearance of the buttons on the menu bar 
 * by setting the number of pixels of button height and width
 */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100

/* Buttons*/
#define NUM_BUTTONS 	7
#define SELECTED_COLOR  RED

/* Position of the card in the window */
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH + 10)
#define PAGE_LLY (-GP142_YMAX + 20)
#define PAGE_WIDTH (GP142_XMAX - PAGE_LLX)
#define PAGE_HEIGHT (GP142_YMAX - PAGE_LLY)

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0
#define NOFILL 1

/* Types of objects we support.*/
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

/*Maximum number of objects */
#define MAX 30

/*Number of shapes and first one*/
#define MAX_SHAPES 7
#define FIRST_SHAPE_NUM 0

/* Shapes */
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_BIG_HEART  2
#define SHAPE_SUN  3
#define SHAPE_ANOTHER_HEART 4
#define SHAPE_FACE  5
#define SHAPE_SMALL_HEART 6

/*Number of messages and first one*/
#define MAX_MESSAGES 7
#define FIRST_MESSAGE_NUM 0

/* Messages. */
#define MESSAGE_MY_HEART 0
#define MESSAGE_ONLY_HEART  1
#define MESSAGE_HAPPY  2
#define MESSAGE_GREY   3
#define MESSAGE_DEAR   4
#define MESSAGE_LOVE_YOU   5
#define MESSAGE_AWAY   6


/*Possible places for mouse clicks*/
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	

/*Drawing the face of the Draw Heart Function */
#define PI 3.14			
#define HEART_2_WIDTH 250 /* width of the large card face heart */

/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions amd Message functions */
void DrawBlankScreen (int *background_color);
void DrawButtons(int *last_button, int background_color);
void DrawCard (int background_color, int status, int *object_count, 
			   int object_type[MAX], int object_num[MAX], 
			   int object_color[MAX], int object_x[MAX], int object_y[MAX]);
void DrawMessage(int message_type, int color, int bottom_x, int bottom_y);
void DrawShape(int color, int shape_type, int bottom_x, int bottom_y);
void DrawHeart (int x, int y, int color, int width, int change, 
				int change_triangle) ;
void DrawSun (int x, int y, int color);
void DrawFace (int x, int y, int color);
void DrawStar (int x, int y, int color);

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int object_type[MAX], 
					  int object_num[MAX], int object_color[MAX], 
					  int object_x[MAX], int object_y[MAX], int *current_object,
					  int *last_button, int *quit);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *background_color, int *status,
				  int object_count, int object_type[MAX], int object_num[MAX], 
				  int object_color[MAX], int *current_object, int *last_button);

/* Add a shape to the card. */
void AddObject(int x, int y, int *status, int *object_count, 
			   int object_type[MAX], int object_num[MAX], int object_color[MAX], 
			   int object_x[MAX], int object_y[MAX], int *current_object);
/* Select object */
void Select_Object (int x_close, int y_close,
                       int *object_count,
                       int object_x[MAX], int object_y[MAX]);

/* Selected object get's new coordinates */
void WhichObject (int x, int y, int object_x[], int object_y[], int object_count);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */
	
	
	/*variables and their default values*/
	int background_color = GREEN;
	int status = STATUS_ADD_SHAPE;
	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */
	int object_count = 0;           /* How many objects on the page? */
	int object_type [MAX];  /* Can also be a shape           */
	int object_num[MAX];                 /* If type is shape, either 
									   heart or star                 */
	int object_color[MAX];               /* Color of object               */
	int object_x[MAX];                   /* Position of object            */
	int object_y[MAX];
	
	int last_button = -1;           /* Keep track of the last button clicked.
	                                   This would be usefull when highlighting
	                                   the last button the user clicked */

	int event; /*the most recent GP142 event*/
    int current_object;
	
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/
	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen (&background_color);
		
		DrawCard (background_color, status, &current_object, 
			      object_type, object_num, object_color, object_x, object_y);
		DrawButtons(&last_button, background_color);	  /* Show the buttons...*/ 
		
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 
					         &object_count, object_type, 
							 object_num, object_color, 
							object_x, object_y, &current_object, &last_button,
							&quit);			
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed,*/
			/*not currently used in the program*/		
			break;

		default:
			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (int *background_color) {
	int font_size = 14;

	GP142_rectangleXY (*background_color,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);
} 
/* 
 ***************************************************************************
 * Draws the buttons 
 */
void DrawButtons(int *last_button, int color)
{
/* To add buttons, you'll need to change the #defined constant NUM_BUTTONS
 * and add messages to this array.*/
	char b_labels [NUM_BUTTONS][25] = {
		"Background color", "Next, please", "Add shape", 
			"Change Color", "Add Message", "Select Object","QUIT"};
	
	int i = 0, text_offset = -GP142_XMAX + 6, font_size = 12;
	int y, label_y;
	
	/* draw rectangles and labels for each button */
	for (i = 0; i < NUM_BUTTONS; i++) 
	{
		y = GP142_YMAX - i * BUTTON_HEIGHT;
		
		GP142_rectangleXY(BLACK, -GP142_XMAX + 6, y - 2,
			-GP142_XMAX + BUTTON_WIDTH, y - BUTTON_HEIGHT - 2, 8);
		
		GP142_rectangleXY(WHITE, -GP142_XMAX + 7, y - 3,
			-GP142_XMAX + BUTTON_WIDTH - 1, y - BUTTON_HEIGHT - 4, FILL);
		
		label_y = y - BUTTON_HEIGHT/2;
		
		if (i == *last_button)
			GP142_printfXY(color, text_offset, label_y, font_size, 
			b_labels[i]);	
		else
			GP142_printfXY(BLACK, text_offset, label_y, font_size, b_labels[i]);	
	}	
}
/*
 ******************************************************************************
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, int status, int *object_count, 
			   int object_type[MAX], int object_num[MAX], 
			   int object_color[MAX], int object_x[MAX], int object_y[MAX])
{
	int font_size = 14;
	int i;
	
	/*
	 * background: Heart pulsating
	 * by drawing a pulsating heart and lines as if the sun is shinning.
	 */

	/* pulsating lines on the card with use of random function */
	int sp;
	double angle;
	int x = 0, y = 0, x1, y1;
	int h;
	sp = 30;
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * 300) + rand () % 100;
		y1 = (int) (sin (angle) * 300) + rand () % 100;
		GP142_lineXY (YELLOW, x+x1, y+y1, x-x1, y-y1, 20);
	}
     
	/* pulsating heart on top of the lines */
	h = (HEART_2_WIDTH/2) + (rand () % 40);
	GP142_circleXY (RED, x - h + 30, y + 60, h);
	GP142_circleXY (RED, x + h - 30, y + 60, h);
	GP142_triangleXY (RED, x - h*2 + 25, (y + 60) - 25,
						 x + h*2 - 30, (y + 60) - 25,
						 x, (y + 60) - h*2 - 30, FILL);
	
	/* 
	 * Draw objects on the card. If the object type is a shape, draw a shape.
	 * If also a message, draw a message.
	 */

	if (*object_count > 0)
	{
		for (i = 0; i<MAX; i++)
		{
			if (object_type[i] == OBJECT_SHAPE)
			{
			DrawShape (object_num[i], object_color[i], object_x[i], object_y[i]);
			}
		    else if (object_type[i] == OBJECT_MESSAGE)
			{
			DrawMessage(object_num[i], object_color[i], object_x[i], object_y[i]);
			}  
		}
	}
	
	/* 
	 * Heading of the card telling the user that it's a valentines day card.
	 */

	GP142_printfXY (BLACK, PAGE_LLX, PAGE_LLY + 430, font_size + 20,
			"HAPPY VALENTINES DAY!");
  
	/*
	 * Write an appropriate status message below the background
	 */
	switch (status) {
	case STATUS_ADD_SHAPE:
		GP142_printfXY (BLACK, PAGE_LLX + 50, PAGE_LLY + 20, font_size + 3,
			"Click on the card to add a shape");
		break;
	case STATUS_ADD_MESSAGE:
		GP142_printfXY (BLACK, PAGE_LLX + 50, PAGE_LLY + 20, font_size + 3,
			"Click on the card to add a message");
		break;
	case STATUS_SELECTED:
		GP142_printfXY (BLACK, PAGE_LLX + 40, PAGE_LLY + 20, font_size - 5,
			"Object selected. Click on change color or next please to change type.");
		break;
	case SELECT_OBJECT:
	  GP142_printfXY (BLACK, PAGE_LLX + 50, PAGE_LLY + 20, font_size - 3,
			"Click close to the object's origin to select it.");
		break;
	case STATUS_QUIT:
		break;
	default:
		GP142_printfXY (BLACK, PAGE_LLX + 50, PAGE_LLY + 20, font_size,
			"Status error -- notify programmer");
		break;
	} /*end switch */
} 
/*
 ******************************************************************************
 * Draw a message. 
 * The functions move with the help of a random function which each time
 * adds a random number to the desired coordinates
 */
void DrawMessage(int message_type, int color, int bottom_x, int bottom_y) {
	int font_size = 18;
	switch ((message_type ) % MAX_MESSAGES) {
	case MESSAGE_MY_HEART:
		bottom_x = (bottom_x + rand()) / PAGE_LLX ;
		bottom_y = (bottom_y + rand()) / PAGE_LLY ;
		GP142_printfXY (color, bottom_x, bottom_y, font_size + 3,
			"YOU MAKE MY HEART SHINE!");
		break;
	case MESSAGE_ONLY_HEART:
		GP142_printfXY (color, bottom_x, bottom_y, font_size - 3,
			"MY ONLY HEART SHINE!");
		break;
	case MESSAGE_HAPPY:
		GP142_printfXY (color, bottom_x, bottom_y, font_size - 2,
			"YOU MAKE ME HAPPY!");
		break;
	case MESSAGE_GREY:
		GP142_printfXY (color, bottom_x, bottom_y, font_size - 1,
			"WHEN DAYS ARE GREY!");
		break;
	case MESSAGE_DEAR:
		GP142_printfXY (color, bottom_x, bottom_y, font_size - 3,
			"I WANT YOU TO KNOW DEAR!");
		break;
	case MESSAGE_LOVE_YOU:
		bottom_x = (bottom_x + rand()) / PAGE_LLX ;
		bottom_y = (bottom_y + rand()) / PAGE_LLY ;
		GP142_printfXY (color, bottom_x, bottom_y, font_size + 13,
			"I LOVE YOU!");
		break;
	case MESSAGE_AWAY:
		GP142_printfXY (color, bottom_x, bottom_y, font_size - 3,
			"NOONE WILL TAKE MY SUNSHINE AWAY!");
	default:;
	}
}
/*
 ****************************************************************************
 * Draw a shape.
 *
 */
#define HEART_WIDTH 35
void DrawShape(int shape_type, int color, int bottom_x, int bottom_y) {

  switch ((shape_type ) % MAX_SHAPES)
  { 
	case SHAPE_HEART:
		DrawHeart (bottom_x, bottom_y, color, HEART_WIDTH, 0, 0);
		break;
	case SHAPE_STAR:
		DrawStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_BIG_HEART:
		DrawHeart (bottom_x, bottom_y, color, 60, 5, 5);
		break;
	case SHAPE_SUN:
		DrawSun (bottom_x, bottom_y, color);
		break;
	case SHAPE_ANOTHER_HEART:
		DrawHeart (bottom_x, bottom_y, color, 20, 5, 5);
		break;
	case SHAPE_FACE:
		DrawFace (bottom_x, bottom_y, color);
		break;
	case SHAPE_SMALL_HEART:
		DrawHeart (bottom_x, bottom_y, color, 20, 5, 5);
		break;
	default:
		/* Unknown shape selected */
    break;
  }

	 /*end switch*/
}
/*
 *****************************************************************************
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 *
 * The size of the heart depends on the width, change and change_triangle.
 */
void DrawHeart (int x, int y, int color, int width, int change, 
				int change_triangle) {
    
	int h = (width/2) + (rand () %4);
	GP142_circleXY (color, x - h + change, y, h);
	GP142_circleXY (color, x + h - change, y, h);
	GP142_triangleXY (color, x - h*2 + change_triangle, y - change,
						x + h*2 - change, y - change,
						x, y - h*2 - change, FILL);
}
/*
 ***************************************************************************
 * Draw a sun on the card. A sun will be made by a circle, 
 * and a combinations of lines.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * suns height each time this function is called.
 */ 
#define SUN_WIDTH 40
#define SUNPOINTS 12
#define SUNRADIUS 35

void DrawSun (int x, int y, int color) 
{
	int h = (SUN_WIDTH/2) + (rand () % 5);
	int sp;
	double angle;
	int x1, y1;
    
	sp = SUNPOINTS;

	
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * SUNRADIUS);
		y1 = (int) (sin (angle) * SUNRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 3);

	GP142_circleXY (color, x, y, h);

	}
}
/*
 ***************************************************************************
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */
#define STARPOINTS 20
#define STARRADIUS 20

void DrawStar (int x, int y, int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);
	}
}
/*
 *******************************************************************************
 * Draw a face on the card.
 * Will Draw a face by drawing a circle with circles for eyes and mouth. 
 * We make the mouth open and close by selecting adding a random number to the
 * area of the circle standing for mouth.
 */
#define EYE_RADIUS 3
#define MOUTH_WIDTH 10
#define FACE_RADIUS 25

void DrawFace (int x, int y, int color) {
	int h = (MOUTH_WIDTH/2) + (rand () % 5);
	int x1 = x - 15, x2 = x + 15, y1 = y - 10;
	
	GP142_circleXY (color, x, y, FACE_RADIUS); /* face */
	color = BLACK;
    GP142_circleXY (color, x1, y + 12,  EYE_RADIUS); /* eyes */
	GP142_circleXY (color, x2, y + 12,  EYE_RADIUS);
	GP142_circleXY (color, x,  y1, h); /* mouth */
}
/*
 *************************************************************************
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int  ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return CLICK_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    return CLICK_CARD;
  else
    return CLICK_OUTSIDE;
}
/*
 *************************************************************************
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *object_count, int *object_type, 
					  int object_num[MAX], int object_color[MAX], 
					  int object_x[MAX], int object_y[MAX], int *current_object, 
					  int *last_button, int *quit)
{
	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
		
	if (mouse_click == CLICK_BUTTON) 
	{
		/* A button has been clicked.  Call a function to handle it*/
		HandleButton(mouse_x, mouse_y, background_color, status, 
					 *object_count, object_type, object_num, object_color, 
					 current_object, last_button);
	
		if (*status == STATUS_QUIT)  
		{	/*move the selected object around the screen */
			*quit = TRUE;
		}
	} 
	else if (mouse_click == CLICK_CARD) 
	{
	
		if(* status == STATUS_ADD_MESSAGE || *status == STATUS_ADD_SHAPE)
		{
			/* Add an object if there is room for one */
			AddObject(mouse_x, mouse_y, status, object_count, 
					object_type, object_num, object_color, 
					object_x, object_y, current_object);
		}
		else if (*status == SELECT_OBJECT)
		{	/* Select the object you clicked on*/
			Select_Object (mouse_x, mouse_y, current_object, object_x, object_y);
			*status = STATUS_SELECTED;
		} 
		else if (*status = STATUS_SELECTED)
		{
		WhichObject (mouse_x, mouse_y, object_x, object_y, *current_object);
		}	
	
		
	}
}
/* 
 *****************************************************************************
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, int y, int *background_color, int *status,
				  int object_count, int object_type[MAX], int object_num[MAX], 
				  int object_color[MAX], int *current_object, int *last_button)
{ 
	
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH)  
		return ;	/*That's an error situation*/
					/* We know the mouse clicked in the column of buttons. Calculate
					* which one.
					*/
	*last_button = (GP142_YMAX - y)/BUTTON_HEIGHT;	 
	
	switch(*last_button) {
	case 0:
		/* Change the background color */
		*background_color = (*background_color + 1) % MAX_COLORS;
		break;
	case 1:
		/* Change the type of the currently selected object */ 
		if (*current_object > 0 && *status == STATUS_SELECTED)  
		{
		object_num[*current_object] = (object_num[*current_object] + 1) 
			% MAX_SHAPES;
		*status = STATUS_SELECTED; 
		}
		else
		{
		*status = STATUS_ADD_SHAPE; 
		}
		break;
	case 2:
		/* Add Shape*/
		 *status = STATUS_ADD_SHAPE;
		break;
	case 3:
		/*Change the color of the selected object. */
		if (*status == STATUS_SELECTED && *current_object > 0)
		{
		object_color[*current_object] = (object_color[*current_object] + 1)
			% MAX_COLORS;
		*status = STATUS_SELECTED;}
		else
		{
		*status = STATUS_ADD_SHAPE; 
		}
		break;
	case 4:
		/* Add a message*/
		*status = STATUS_ADD_MESSAGE; 
		break;
	case 5:
		/*Determine which shape was selected */
		if (*status == STATUS_SELECTED && *current_object > 0)
		{
		*status = SELECT_OBJECT;
		}
		break;
	case 6:
		*status = STATUS_QUIT;
		break;
	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}

/*
 ******************************************************************************
 * If there's room for another object, add it to the card. 
 */
void AddObject(int x, int y, int *status, int *object_count, 
			   int object_type[MAX], int object_num[MAX], 
			   int object_color[MAX], int object_x[MAX], int object_y[MAX],
			   int *current_object)
{ 	
  if ((*object_count < MAX) && (*status == STATUS_ADD_SHAPE)) 
  {
	*object_count = *object_count + 1;           
    *current_object = *object_count;              
	*status = STATUS_SELECTED;
	object_type[*current_object] = OBJECT_SHAPE;
	object_num [*current_object] = SHAPE_HEART;
	object_color [*current_object] = YELLOW;
	object_x[*current_object] = x;
	object_y[*current_object] = y;
  }
  else if ((*object_count < MAX) && (*status == STATUS_ADD_MESSAGE))
  {
	*object_count = *object_count + 1;
    *current_object = *object_count; 
	*status = STATUS_SELECTED;
	object_type[*current_object] = OBJECT_MESSAGE;
	object_num [*current_object] = MESSAGE_LOVE_YOU;
	object_color [*current_object] = WHITE;
	object_x[*current_object] = x;
	object_y[*current_object] = y;
  }
}
/*
 ******************************************************************************
 * Decide which object was selected. 
 */ 
#define DIF_DIST 15  /*difference in coordinates*/
void Select_Object (int x_close, int y_close, int *current_object,
                       int object_x[MAX], int object_y[MAX])
{  int i;
   for (i = 0; (i < MAX) ; i++)
	{
		if (((object_x[i] > (x_close - DIF_DIST))       /* if click is close */
			 && (object_x[i] < (x_close + DIF_DIST)))   /* to object's */
			 && (( object_y[i]> (y_close - DIF_DIST))   /* origin */
			 &&(object_y[i] < (y_close + DIF_DIST))))
		{
			  *current_object = i;
			  
			  object_x[*current_object] = x_close;
			  object_y[*current_object] = y_close;
			  i++;
			  break;
			  
        }
	}
}
/*
 *******************************************************************************
 * Gives the selected object new coordinates
 */
void WhichObject (int x, int y, int object_x[], int object_y[], int object_count)
{
     object_x[object_count] = x;
	 object_y[object_count] = y;
}
/*******************************************************************************/